﻿Imports System.ComponentModel

Imports System.Text

' Use Winnovative Namespace
Imports Winnovative

Namespace WnvHtmlToPdfDemo.HTML_to_PDF.PDF_Security
	Partial Public Class PDF_Permissions_and_Password_Demo
		Inherits UserControl
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub convertToPdfButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles convertToPdfButton.Click
			' Create a HTML to PDF converter object with default settings
			Dim htmlToPdfConverter As New HtmlToPdfConverter()

			' Set license key received after purchase to use the converter in licensed mode
			' Leave it not set to use the converter in demo mode
			htmlToPdfConverter.LicenseKey = "fvDh8eDx4fHg4P/h8eLg/+Dj/+jo6Og="

			' Set user and owner passwords
			If userPasswordTextBox.Text.Length > 0 Then
				htmlToPdfConverter.PdfSecurityOptions.UserPassword = userPasswordTextBox.Text
			End If

			If ownerPasswordTextBox.Text.Length > 0 Then
				htmlToPdfConverter.PdfSecurityOptions.OwnerPassword = ownerPasswordTextBox.Text
			End If

			If htmlToPdfConverter.PdfSecurityOptions.UserPassword IsNot Nothing AndAlso htmlToPdfConverter.PdfSecurityOptions.UserPassword.Length > 0 AndAlso (htmlToPdfConverter.PdfSecurityOptions.OwnerPassword Is Nothing OrElse htmlToPdfConverter.PdfSecurityOptions.OwnerPassword.Length = 0 OrElse htmlToPdfConverter.PdfSecurityOptions.UserPassword = htmlToPdfConverter.PdfSecurityOptions.OwnerPassword) Then
				' A user password is set but the owner password is not set or is identical to user password
				' Set a different owner password
				htmlToPdfConverter.PdfSecurityOptions.OwnerPassword = htmlToPdfConverter.PdfSecurityOptions.UserPassword & "_owner"
			End If

			' Set PDF document permissions
			htmlToPdfConverter.PdfSecurityOptions.CanPrint = printEnabledCheckBox.Checked
			htmlToPdfConverter.PdfSecurityOptions.CanCopyContent = copyContentEnabledCheckBox.Checked
			htmlToPdfConverter.PdfSecurityOptions.CanEditContent = editContentEnabledCheckBox.Checked
			htmlToPdfConverter.PdfSecurityOptions.CanEditAnnotations = editAnnotationsEnabledCheckBox.Checked
			htmlToPdfConverter.PdfSecurityOptions.CanFillFormFields = fillFormFieldsEnabledCheckBox.Checked

			Cursor = Cursors.WaitCursor

			' Convert HTML to PDF using the settings above
			Dim outPdfFile As String = "DemoAppFiles\Output\HTML_to_PDF\Set_Permissions_Password.pdf"
			Try
				' Convert the HTML page to a PDF document in a memory buffer
				Dim outPdfBuffer() As Byte = htmlToPdfConverter.ConvertUrl(urlTextBox.Text)

				' Write the memory buffer in a PDF file
				System.IO.File.WriteAllBytes(outPdfFile, outPdfBuffer)
			Catch ex As Exception
				' The HTML to PDF conversion failed
				MessageBox.Show(String.Format("HTML to PDF Error. {0}", ex.Message))
				Return
			Finally
				Cursor = Cursors.Arrow
			End Try

			' Open the created PDF document in default PDF viewer
			Try
				Process.Start(outPdfFile)
			Catch ex As Exception
				MessageBox.Show(String.Format("Cannot open created PDF file '{0}'. {1}", outPdfFile, ex.Message))
			End Try
		End Sub

		Private Sub editContentEnabledCheckBox_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles editContentEnabledCheckBox.CheckedChanged
			If editContentEnabledCheckBox.Checked Then
				fillFormFieldsEnabledCheckBox.Checked = True
			End If
		End Sub

		Private Sub editAnnotationsEnabledCheckBox_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles editAnnotationsEnabledCheckBox.CheckedChanged
			If editAnnotationsEnabledCheckBox.Checked Then
				fillFormFieldsEnabledCheckBox.Checked = True
			End If
		End Sub

		Private Sub fillFormFieldsEnabledCheckBox_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles fillFormFieldsEnabledCheckBox.CheckedChanged
			If Not fillFormFieldsEnabledCheckBox.Checked Then
				editContentEnabledCheckBox.Checked = False
				editAnnotationsEnabledCheckBox.Checked = False
			End If
		End Sub
	End Class
End Namespace
